//
//  CounterOperation.m
//  BlockMTDemo
//
//  Created by Martin Banas on 09/04/14.
//  Copyright (c) 2014 Martin Banas. All rights reserved.
//

#import "CounterOperation.h"

typedef void (^OperationBlock)();

@implementation CounterOperation {
    OperationBlock _operationBlock;
}

- (instancetype)initWithBlock:(void (^)())block {
    self = [super init];
    if (self) {
        _operationBlock = block;
    }
    return self;
}

- (void)main {
    @autoreleasepool {
        
        for (int i = 0; i < 10000; i++) {
            if(self.isCancelled) {
                return;
            }
            
            NSLog(@"%i",i);
        }
        
        if (_operationBlock) {
            _operationBlock();
        }
    }
}

@end
