//
//  DetailViewController.m
//  BlockMTDemo
//
//  Created by Martin Banas on 09/04/14.
//  Copyright (c) 2014 Martin Banas. All rights reserved.
//

#import "DetailViewController.h"
#import "CounterOperation.h"

@implementation DetailViewController {
    NSDate *_startTime;
    NSOperationQueue *_counterQueue;
    CounterOperation *_counterOperation;
}

- (void)dealloc {
    NSLog(@"$$$$$$$$$$$$ %@",NSStringFromClass([self class]));
}

- (void)viewDidLoad {
    [super viewDidLoad];
    
    _titleLabel.text = nil;
    _startTime = [NSDate date];

    if (_task == 2) {
        _counterQueue = [NSOperationQueue new];
        
        __weak __typeof(self)weakSelf = self;
        _counterOperation = [[CounterOperation alloc] initWithBlock:^{
            if (weakSelf) {
                __strong __typeof(weakSelf)strongSelf = weakSelf;
                
                NSDate *stopTime = [NSDate date];
                NSTimeInterval executionTime = [stopTime timeIntervalSinceDate:strongSelf->_startTime];
                
                dispatch_async(dispatch_get_main_queue(), ^{
                    strongSelf->_titleLabel.text = [NSString stringWithFormat:@"%f", executionTime];
                    strongSelf->_indicatorView.hidden = YES;
                });
            }
        }];
       [_counterQueue addOperation:_counterOperation];
        
    } else if (_task == 1) {
        dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^(void){
            [self performLongTask];
        });
    } else {
        [self performLongTask];
    }
}

- (void)viewWillDisappear:(BOOL)animated {
    [super viewWillDisappear:animated];
    
    [_counterQueue cancelAllOperations];
}

#pragma mark - Private methods

- (void)performLongTask {
    for (int i = 0; i < 10000; i++) {
        NSLog(@"%i",i);
    }
    
    NSDate *stopTime = [NSDate date];
    NSTimeInterval executionTime = [stopTime timeIntervalSinceDate:_startTime];
    
    dispatch_async(dispatch_get_main_queue(), ^{
        _titleLabel.text = [NSString stringWithFormat:@"%f", executionTime];
        _indicatorView.hidden = YES;
    });
}

@end
